import java.util.concurrent.locks.*;

public class BoundedQueue<E> {
    private Object[] elements;
    private int front, rear, numItems;
    
    public BoundedQueue(int capacity)    {
        elements = new Object[capacity];
        front = numItems = 0; rear = -1;
    }
    public synchronized E remove() throws InterruptedException {
        while (numItems == 0)
            wait();
        E r = (E) elements[front];
        front = (front+1)%elements.length;
        numItems--;
        notifyAll();
        return r;
    }
    public synchronized void add(E newValue) throws InterruptedException {
        while (numItems == elements.length)
            wait();
        rear = (rear+1)%elements.length;
        elements[rear] = newValue;
        numItems++;
        notifyAll();
    }
}
